package com.jsowell.thirdparty.common;

import com.jsowell.common.enums.ykc.ReturnCodeEnum;
import com.jsowell.common.exception.BusinessException;
import com.jsowell.common.util.StringUtils;
import com.jsowell.pile.vo.ThirdPartySecretInfoVO;
import com.jsowell.thirdparty.platform.service.ThirdPartyPlatformService;
import com.jsowell.thirdparty.platform.factory.ThirdPartyPlatformFactory;
import com.jsowell.thirdparty.service.ThirdpartySecretInfoService;
import org.apache.commons.collections4.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 主动通知Service
 * 说明：创建此接口目的是为了简化开发
 * 在需要通知第三方平台的地方，异步调用此类中对应的方法
 * 通知方法中应该根据对接平台，自动找到响应的平台处理逻辑
 */
@Service
public class NotificationService {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private ThirdpartySecretInfoService thirdpartySecretInfoService;

    /**
     * 充电站信息变化推送
     * notification_stationInfo
     */
    public void notificationStationInfo(NotificationDTO dto) {
        String stationId = dto.getStationId();
        String platformType = dto.getPlatformType();

        if (StringUtils.isBlank(stationId)) {
            throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
        }
        // 通过stationId 查询该站点需要对接的平台配置
        List<ThirdPartySecretInfoVO> secretInfoVOS = thirdpartySecretInfoService.queryStationToPlatformList(stationId);
        if (CollectionUtils.isEmpty(secretInfoVOS)) {
            return;
        }
        // 调用相应平台的处理方法
        for (ThirdPartySecretInfoVO secretInfoVO : secretInfoVOS) {
            if (StringUtils.isNotBlank(platformType) && !StringUtils.equals(platformType, secretInfoVO.getPlatformType())) {
                // 如果dto中的platformType不为空，并且不等于secretInfoVO.getPlatformType()，continue
                continue;
            }
            try {
                ThirdPartyPlatformService platformService = ThirdPartyPlatformFactory.getInvokeStrategy(secretInfoVO.getPlatformType());
                platformService.notificationStationInfo(stationId);
            } catch (Exception e) {
                logger.error("充电站信息变化推送error", e);
            }
        }
    }

    /**
     * 设备状态变化推送
     * notification_stationStatus
     */
    public void notificationStationStatus(NotificationDTO dto) {
        String stationId = dto.getStationId();
        String pileConnectorCode = dto.getPileConnectorCode();
        String status = dto.getStatus();
        String platformType = dto.getPlatformType();

        if (StringUtils.isBlank(stationId) || StringUtils.isBlank(pileConnectorCode) || StringUtils.isBlank(status)) {
            throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
        }
        // 通过stationId 查询该站点需要对接的平台配置
        List<ThirdPartySecretInfoVO> secretInfoVOS = thirdpartySecretInfoService.queryStationToPlatformList(stationId);
        if (CollectionUtils.isEmpty(secretInfoVOS)) {
            return;
        }
        // 调用相应平台的处理方法
        for (ThirdPartySecretInfoVO secretInfoVO : secretInfoVOS) {
            if (StringUtils.isNotBlank(platformType) && !StringUtils.equals(platformType, secretInfoVO.getPlatformType())) {
                // 如果dto中的platformType不为空，并且不等于secretInfoVO.getPlatformType()，continue
                continue;
            }
            try {
                // 根据平台类型获取Service
                ThirdPartyPlatformService platformService = ThirdPartyPlatformFactory.getInvokeStrategy(secretInfoVO.getPlatformType());
                platformService.notificationStationStatus(stationId, pileConnectorCode, status, secretInfoVO);
            } catch (Exception e) {
                logger.error("设备状态变化推送error", e);
            }
        }
    }

    /**
     * 设备充电中状态变化推送
     * notification_connector_charge_status
     * notification_equip_charge_status
     */
    public void notificationConnectorChargeStatus(NotificationDTO dto) {
        String stationId = dto.getStationId();
        String orderCode = dto.getOrderCode();
        String platformType = dto.getPlatformType();
        if (StringUtils.isBlank(stationId) || StringUtils.isBlank(orderCode)) {
            throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
        }
        // 通过stationId 查询该站点需要对接的平台配置
        List<ThirdPartySecretInfoVO> secretInfoVOS = thirdpartySecretInfoService.queryStationToPlatformList(stationId);
        if (CollectionUtils.isEmpty(secretInfoVOS)) {
            return;
        }
        // 调用相应平台的处理方法
        for (ThirdPartySecretInfoVO secretInfoVO : secretInfoVOS) {
            if (StringUtils.isNotBlank(platformType) && !StringUtils.equals(platformType, secretInfoVO.getPlatformType())) {
                // 如果dto中的platformType不为空，并且不等于secretInfoVO.getPlatformType()，continue
                continue;
            }
            try {
                // 根据平台类型获取Service
                ThirdPartyPlatformService platformService = ThirdPartyPlatformFactory.getInvokeStrategy(secretInfoVO.getPlatformType());
                platformService.notificationConnectorChargeStatus(orderCode, secretInfoVO);
            } catch (Exception e) {
                logger.error("设备充电中状态变化推送error:{}", e.getMessage());
            }
        }
    }

    /**
     * 充电订单信息推送
     * notification_orderInfo/notification_charge_order_info
     */
    public void notificationChargeOrderInfo(NotificationDTO dto) {
        String stationId = dto.getStationId();
        String orderCode = dto.getOrderCode();
        String platformType = dto.getPlatformType();
        if (StringUtils.isBlank(stationId) || StringUtils.isBlank(orderCode)) {
            throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
        }
        // 通过stationId 查询该站点需要对接的平台配置
        List<ThirdPartySecretInfoVO> secretInfoVOS = thirdpartySecretInfoService.queryStationToPlatformList(stationId);
        if (CollectionUtils.isEmpty(secretInfoVOS)) {
            return;
        }
        // 调用相应平台的处理方法
        for (ThirdPartySecretInfoVO secretInfoVO : secretInfoVOS) {
            if (StringUtils.isNotBlank(platformType) && !StringUtils.equals(platformType, secretInfoVO.getPlatformType())) {
                // 如果dto中的platformType不为空，并且不等于secretInfoVO.getPlatformType()，continue
                continue;
            }
            try {
                // 根据平台类型获取Service
                ThirdPartyPlatformService platformService = ThirdPartyPlatformFactory.getInvokeStrategy(secretInfoVO.getPlatformType());
                platformService.notificationChargeOrderInfo(orderCode, secretInfoVO);
            } catch (Exception e) {
                logger.error("充电订单信息推送error", e);
            }
        }
    }

    /**
     * 站点费率变化推送
     * notification_stationFee
     */
    public void notificationStationFee(NotificationDTO dto) {
        String stationId = dto.getStationId();
        String platformType = dto.getPlatformType();

        if (StringUtils.isBlank(stationId)) {
            throw new BusinessException(ReturnCodeEnum.CODE_PARAM_NOT_NULL_ERROR);
        }
        // 通过stationId 查询该站点需要对接的平台配置
        List<ThirdPartySecretInfoVO> secretInfoVOS = thirdpartySecretInfoService.queryStationToPlatformList(stationId);
        if (CollectionUtils.isEmpty(secretInfoVOS)) {
            return;
        }
        // 调用相应平台的处理方法
        for (ThirdPartySecretInfoVO secretInfoVO : secretInfoVOS) {
            if (StringUtils.isNotBlank(platformType) && !StringUtils.equals(platformType, secretInfoVO.getPlatformType())) {
                // 如果dto中的platformType不为空，并且不等于secretInfoVO.getPlatformType()，continue
                continue;
            }
            try {
                // 根据平台类型获取Service
                ThirdPartyPlatformService platformService = ThirdPartyPlatformFactory.getInvokeStrategy(secretInfoVO.getPlatformType());
                platformService.notificationStationFee(stationId, secretInfoVO);
            } catch (Exception e) {
                logger.error("站点费率变化推送error", e);
            }
        }
    }
}
